<template>
  <div class="acceptance__content-column acceptance__content-right additional-style-2" :class="[ line_left ? 'acceptance__content-right-line' : 'acceptance__content-right-without-line']">
    <div class="acceptance__check-card-bank-number">
      <SVGIcon class="acceptance__check-bank-mini-icon" :xlink="bank.id + '-mini'" viewBox="0 0 70 45"/>
      <div class="acceptance__check-card-bank-number-info">
        <p class="acceptance__check-bank">{{bank.name}}</p>
        <p class="acceptance__check-card" :class="[bank.name === '' ? 'without-name-bank-mini' : '']">{{secretCard}}</p>
      </div>
    </div>

    <label for="control-sum-without-3ds" class="acceptance__check-title">Контрольная сумма</label>

    <input class="acceptance__check-input"
           id="control-sum-without-3ds"
           type="tel"
           data-id="control-sum-without-3ds"
           ref="control_sum"
           v-model="controlSum"
           :class="[{error: vErrors.has('control_sum')}, {disabledBlock: block}]"
           name="control_sum"
           v-validate="'required'"
           v-mask="'#.##'"
           :disabled="block"
           @keyup.enter="checkCard"
    />

    <validate-message v-show="vErrors.has('control_sum')" class="bottom-indent">
    {{ vErrors.first('control_sum') ? 'Укажите контрольную сумму' : '' }}
    </validate-message>

    <p class="acceptance__check-description">
      Для подтверждения добавления карты, укажите сумму списанную с вашей карты.
      <b>Узнать сумму вы можете из СМС-уведомления или в личном кабинете Вашего банка из истории операций.</b>
    </p>

    <button class="acceptance__check-button button red"
            @click="checkCard"
            :disabled="block"
    >
      Подтвердить
    </button>

    <button class="acceptance__check-button acceptance__check-button-link button white"
            @click="$emit('cancel_building')"
            :disabled="block"
    >
      Отменить
    </button>
  </div>
</template>

<script>
  import {nameBank} from '@/helpers/bin-banks'
  import SVGIcon from "@/components/SVGIcon";
	export default {
		name: 'Without3DS',
    components: {SVGIcon},
    props: {
      line_left: {
        default: false
      },
      id: {
        default: null
      },
      numberCard: {
        default: ''
      }
    },
    data () {
      return {
        controlSum: '',
        check3DS: true,
        allFields: true,
        block: false,
        isBank: {
          id: 'unknownbank',
          name: ''
        }
      }
    },
    computed: {
      secretCard () {
        if (Object.keys(this.numberCard).length) {
          let series = this.numberCard.split('-');
          return `${series[0]}-${series[1].slice(0, 2)}**-****-${series[3]}`
        } else {
          return ''
        }
      },
      bank () {
        let card = this.numberCard.replace(/-/g, '').slice(0,6);
        this.isBank = nameBank(card);
        return this.isBank

      }
    },
    created () {
        this.$nextTick(() => this.$refs.control_sum.focus())
    },
    methods: {
      checkCard() {
        this.$validator.validateAll()
          .then((control) => {
            if (control) {
              this.block = true
              this.$backend.api.payment.create.check({
                id: this.id,
                sum: this.controlSum
              })
              .then(({data}) => {
                // this.$toastr.success('Карта успешно привязана, оплата будет возвращена вам обратно на карту', 'Успешно')
                this.$emit('resultSuccess', data);
                this.$backend.log({
                                    action: 'add_card',
                                    step: 3,
                                    success: true
                                  });
              })
              .catch((err) => {
                this.$backend.log({
                  action: 'add_card',
                  step: 3,
                  success: false,
                  error: JSON.stringify(err.errors)
                });
                  this.$error(err, {
                  	  SumNotMatch: 'Неверно введена контрольная сумма',
					  exceedCountAttempt: 'Превышено количество попыток ввода кода.',
                      'description-add-validation-error': 'Указанная карта ранее была привязана',
                      'system-error': 'Непредвиденная ошибка. Попробуйте использовать другую карту или повторите запрос позже'
                  }, 'Ошибка проверки карты. Проверьте номер или попробуйте другую.');
              })
              .finally(() => this.block = false)
            } else {
              this.$toastr.error('Для подтверждения карты необходимо указать контрольную сумму', 'Ошибка')
            }
          })
      }
    }
	}
</script>

<style scoped>
  .acceptance__content-right-line {
    margin-top: -17px !important;
    padding: 74px 60px 40px;
  }
  .acceptance__content-right-without-line {
    border-left: none;
    width: 100%;
    padding: 0;
    margin-bottom: -20px;
  }
  .acceptance__check-bank-mini-icon {
    -webkit-box-shadow: none;
    box-shadow: none;
    border: 1px solid #e9eff4;
  }
  .acceptance__check-card-bank-number {
    margin: 0 0 50px;
  }
  .acceptance__check-description{
    margin: 0 0 30px;
  }
  .red {
   margin-top: -15px;
  }
  .without-name-bank-mini {
    margin-top: 12px;
  }
  @media (max-width: 1099px) {
    .acceptance__content-right{
      border-left: none;
    }
  }
</style>
